//+------------------------------------------------------------------+
//|                                    Envelope Trailing Stop v1.mq4 |
//|                            Copyright  2011, Metacuotes Software |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+

#property copyright ""
#property link      ""
//Variable declaration
extern double Lots = 0.1;
extern string text1 = "Envelope Settings";
extern int Ma_period = 1;//if set to 1/simple/open price, it'll be equal to the open price of every new candle.
extern int Ma_method = 0; //0:SMA 1:EMA 2:SMMA 3:LWMA 
extern int Ma_shift = 0;
extern int Applied_Price = 1; //0:Close 1:Open 2:High 3:Low 4:Median 5:Typical 6:Weighted
extern double deviation = 0.1; //0.01 deviation is equal to 14 pips aprox.
extern int Candle_Shift = 0;
extern string text2 = "Trailing Settings";
extern bool TrailingStop = TRUE;//if FALSE the EA won't work
extern double Start = 1;//pips necesary for the EA to start trailing stop.
//extern int TakeProfit = 350;
extern int StopLoss = 364;//initial stop loss
string gs_140;
string gs_148;
extern int MagicNumber = 0;  //0:for manual trades, if using EA to execute trades change this number to match.
extern int maxspread = 50;
extern int slippage = 50;
double gd_168;
string gs_176 = "Envelope trailing Settings";

int init() {
   return (0);
}

int deinit() {
   return (0);
}

int start() {
   double ld_0;
   double l_ienvelopes_8 = iEnvelopes(Symbol(), 0, Ma_period, Ma_method, Ma_shift, Applied_Price, deviation, MODE_UPPER, Candle_Shift);
   double ld_16 = MarketInfo(Symbol(), MODE_STOPLEVEL);
   double l_ienvelopes_24 = iEnvelopes(Symbol(), 0, Ma_period, Ma_method, Ma_shift, Applied_Price, deviation, MODE_LOWER, Candle_Shift);
   double l_spread_32 = MarketInfo(Symbol(), MODE_SPREAD);
   if (Digits == 2 || Digits == 4) ld_0 = 1;
   if (Digits == 3 || Digits == 5) ld_0 = 10;
   if (Digits == 6) ld_0 = 100;
   //TakeProfit *= ld_0;
   StopLoss *= ld_0;
   int l_ord_total_40 = OrdersTotal();
   int l_count_44 = 0;
   int l_count_48 = 0;
   int l_count_52 = 0;
   for (int l_pos_56 = 0; l_pos_56 < l_ord_total_40; l_pos_56++) {
      OrderSelect(l_pos_56, SELECT_BY_POS, MODE_TRADES);
      
      }
      
   Comment(gs_176, 
      "\n", "bsline = ", l_ienvelopes_8, 
      "\n", "ssline = ", l_ienvelopes_24, 
      "\n", "StopLevel=", ld_16, 
      "\n", "Spread=", l_spread_32, 
      "\n", "Digits=", Digits, 
      "\n", "Pip=", gd_168, 
      "\n", "Order=", l_count_44, 
      "\n", "Trend=", gs_140, 
      "\n", "Action=", gs_148, 
   "\n");
   if (l_spread_32 < maxspread) {
      if (Bid < l_ienvelopes_8) {
         if (l_count_52 == 0) {
            gs_140 = "Bullish";
            
         }
      } else {
         if (l_count_48 == 0) {
            gs_140 = "Bearish";
            
         }
      }
   }
   l_ord_total_40 = OrdersTotal();
   for (l_pos_56 = 0; l_pos_56 < l_ord_total_40; l_pos_56++) {
      OrderSelect(l_pos_56, SELECT_BY_POS, MODE_TRADES);
      
      if (OrderType() == OP_BUY && OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) {
         gd_168 = NormalizeDouble(Bid, Digits) - NormalizeDouble(OrderOpenPrice(), Digits);
         gd_168 /= Point;
         if (MathAbs(l_ienvelopes_8 - OrderOpenPrice()) / Point > ld_16) {
            if (l_ienvelopes_24 > OrderStopLoss() && TrailingStop == TRUE && Bid>(OrderOpenPrice()+(Start/100000))) {
               OrderModify(OrderTicket(), OrderOpenPrice(), l_ienvelopes_24, 0, 0, Yellow);
               gs_148 = "Modified: BUY Stop Loss";
               Alert("Buy Stop Loss Modified");
            }
         }
      }
      if (OrderType() == OP_SELL && OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) {
         gd_168 = NormalizeDouble(OrderOpenPrice(), Digits) - NormalizeDouble(Ask, Digits);
         gd_168 /= Point;
         if (MathAbs(l_ienvelopes_24 - OrderOpenPrice()) / Point > ld_16) {
            if (l_ienvelopes_8 < OrderStopLoss() && TrailingStop == TRUE && Ask<(OrderOpenPrice()-(Start/100000))) {
               OrderModify(OrderTicket(), OrderOpenPrice(), l_ienvelopes_8, 0, 0, Yellow);
               gs_148 = "Modified: SELL Stop Loss";
               Alert("Sell Stop Loss Modified");
            }
         }
      }
   }
   Comment(gs_176, 
      "\n","",
      
      "\n", "Current pips  =  ", gd_168,
      "\n","",
          
      "\n", "Starts trailing at = ", Start," pips",
      "\n","",
      
             
      "\n", "Deviation = ", deviation,"  Aprox  ", deviation*1400," pips",
      "\n","",
     
      "\n", "Upper envelope Current Value  = ", DoubleToStr(l_ienvelopes_8,5), 
      "\n","",
      
      "\n", "Lower envelope Current Value  = ", DoubleToStr(l_ienvelopes_24,5), 
      "\n","",
      
     
      "\n", "Spread         =", l_spread_32, 
      "\n","",
      
      
      "\n", "Last Action  =", gs_148,
      "\n","",

   "\n");
   return (0);
}